/************************************************************************************************************
**	FileName:	common_type.h
**	Description:	
**	Major Function:	
**
--------------------------------------------------------------------------------------------------------
**	Software:	
**	Hareware:	
**						
**	Company:	ngds
--------------------------------------------------------------------------------------------------------
**	Modified:
**	Author 			Date 			 Comment
________________________________________________________________________________________________________
**	Cesar.Li		2014-11-03		Original
**
**
************************************************************************************************************/


#ifndef	_COMMON_DEFINE_H
#define	_COMMON_DEFINE_H

/*******************************************************************************************************************
**	Hardware  Defined
********************************************************************************************************************/
#if defined(__C51__)
	#define __BIG_ENDIAN			//c51Îª´ó¶Ë
#endif
#ifndef MAX
#define MAX(a,b)	( ( (a) > (b) )? (a):(b) )
#endif
#ifndef MIN
#define MIN(a,b)	( ( (a) > (b) )? (b):(a) )
#endif
#ifndef BOOL_STA
#define BOOL_STA(a)		( (0 == (a))? false:true)
#endif

#ifndef SWAP16
#define SWAP16(s) ((((s) & 0xff) << 8) | (((s) >> 8) & 0xff))  

#define SWAP32(l) (((l) >> 24) | \
           (((l) & 0x00ff0000) >> 8)  | \
           (((l) & 0x0000ff00) << 8)  | \
           ((l) << 24))  
           
#define SWAP24(l) (((l) & 0x00ff0000) >> 16)  | \
			   (((l) & 0x000000ff) << 16) 

#endif



#ifdef __BIG_ENDIAN

#ifndef LL_SWAP16
#define LL_SWAP16(x) SWAP16((uint16_t)(x))
#endif
#ifndef HL_SWAP16
#define HL_SWAP16(x) (x)
#endif
#ifndef LL_SWAP32
#define LL_SWAP32(x) SWAP32((uint32_t)(x))
#endif
#ifndef HL_SWAP32
#define HL_SWAP32(x) (x)
#endif

#else

#ifndef LL_SWAP16
#define LL_SWAP16(x) (x)
#endif
#ifndef HL_SWAP16
#define HL_SWAP16(x) SWAP16((uint16_t)(x))
#endif
#ifndef LL_SWAP32
#define LL_SWAP32(x) (x)
#endif
#ifndef HL_SWAP32
#define HL_SWAP32(x) SWAP32((uint32_t)(x))
#endif

#endif



#define isMORE(large,small)	( ( (large) > (small) )? true: false )
#define isLESS(small,large)	( ( (small) < (large) )? true: false )
#define isEQUAL(a,b)	( ( (a) == (b) )? true: false )
#define countof(a) (sizeof(a) / sizeof(*(a)))

/**@brief Macro for checking if an integer is a power of two.
 *
 * @param[in]   A   Number to be tested.
 *
 * @return      true if value is power of two.
 * @return      false if value not power of two.*/

#ifndef IS_POWER_OF_TWO
#define IS_POWER_OF_TWO(A) ( ((A) != 0) && ((((A) - 1) & (A)) == 0) )
#endif
/*******************************************************************************************************************
**	Parameters
********************************************************************************************************************/


	
#ifndef FALSE 
#define FALSE	false
#endif

#ifndef TRUE
#define TRUE 	true
#endif

#ifndef     BIT
#define     BIT(n)              (1UL << (n))
#endif

#define NOT(a)	 ((bool)!(a))


#ifndef UNUSED_VARIABLE
	#if defined(__C51__)
	#define UNUSED_VARIABLE(X)  (X = X)
	#else
	#define UNUSED_VARIABLE(X)  ((void)(X))
	#endif
#endif

#ifndef UNUSED_PARAMETER
#define UNUSED_PARAMETER(X) UNUSED_VARIABLE(X)
#endif


/**
 *
 *
Description
Constrains a number to be within a range.

Syntax
CONSTRAIN(x, a, b)

Parameters
x: the number to constrain Allowed data types: all data types.
a: the lower end of the range. Allowed data types: all data types.
b: the upper end of the range. Allowed data types: all data types.

Returns
x: if x is between a and b.
a(low): if x is less than a.
b(high): if x is greater than b.
 *
 */
#define CONSTRAIN(x, low, high) ((x) < (low) ? (low) : ((x) > (high) ? (high) : (x))) 

#endif

