/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 IAP upgrade routine:
 Support serial port and USB for FLASH burning

 1. Use the IAP download tool to realize the download PA0 floating (default pull-up input)
 2. After downloading the APP, connect PA0 to ground (low level input), and press
 the reset button to run the APP program.
 3. The routine needs to install the CH372 driver.
 Note: FLASH operation keeps the frequency below 100Mhz, it is recommended that the main
 frequency of IAP be below 100Mhz
 
 */

#include "debug.h"
#include "iap.h"
#include "hw_config.h"
extern u8 End_Flag;
u32 tmp_time = 0;
#if CH32V20_IAP_BOOT
/*********************************************************************
 * @fn      IAP_2_APP
 *
 * @brief   IAP_2_APP program.
 *
 * @return  none
 */
void IAP_2_APP(void) {
    PRINT("jump APP\r\n");
    NVIC_EnableIRQ(Software_IRQn);
    NVIC_SetPendingIRQ(Software_IRQn);
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */

int main(void) {
    Delay_Init();
    USART_Printf_Init(1000000);
    PRINT("SystemClk:%d\r\n", SystemCoreClock);


    USART2_CFG(1000000);
    while(1)
    {
        if( USART_GetFlagStatus(USART2, USART_FLAG_RXNE) != RESET) {
            UART_Rx_Deal();
        }
        tmp_time++;
        if(tmp_time >= 1000*1000){
            tmp_time = 0;
            PRINT("@\n\r");
        }


        if (0)
        {
            Delay_Ms(10);
            IAP_2_APP();
            while(1);
        }
    }
}

#endif
